/**
 * latest-vines widget scripts
 * converts thumbnails to playable clips when clicked 
 * @author Tim Whitlock http://timwhitlock.info
 */
!function( window, document, $, console, undefined ){
    
    function stderr( e ){
        e = e.message|| String(e) || 'Unknown error';
        console && console.error & console.error( 'latest-vines: '+e );
    }
    
    try {
        if( ! $ ){
            throw new Error('jQuery required');
        }

        // find all vine divs and add handler to link
        var nvines = 0;
        $('div.vine').each( function( i, div ){
            var id = div.id;
            if( 0 !== id.indexOf('latest-vines-') ){
                return;
            }
            id += '-vid';
            div = $(div);
            nvines++;
            var link = div.children('a.vine-thumb'),
                size = link.children('img').outerWidth(),
                mp4 = div.attr('data-mp4'),
                jpg = div.attr('data-jpg'),
                vid = $('<video class="video-js vjs-default-skin" id="'+id+'"><source src="'+mp4+'" type="video/mp4"></source></video>'),
                opts = {
                    controls: false,
                    preload: 'auto',
                    //poster: jpg,
                    loop: true,
                    width: size,
                    height: size
               };
           function doReplacement(){
                //vid.attr('poster',jpg);
                vid.css('width',size+'px').css('height',size+'px').attr('width',size).attr('height',size);
                vid.replaceAll(link);
                // <video> is in DOM - initialize video.js for flash fallback
                _V_( id, opts, function(){
                    div.addClass('vine-loaded');
                } );
           }
           // convert immediately if video.js available
           if( window._V_ ){
               opts.autoplay = false;
               doReplacement();
               return;
            }
            // else convert onclick after video.js load
            link.click( function(event){ 
                if( window._V_ ){
                    opts.autoplay = true;
                    doReplacement();
                    event.preventDefault();
                    return false;
                }
            } );                
            // next vine ..
        } );

        // dynamic load of video.js if needed
        if( nvines && ! window._V_ ){
            var body = $(document.body);
            $('<script src="'+location.protocol+'//vjs.zencdn.net/c/video.js"></script>').appendTo(body);
            //$('<link href="https://vjs.zencdn.net/c/video-js.css" rel="stylesheet" />').appendTo(body);
        }
        
    }
    catch( e ){
        stderr(e);
    }
    
}( window, document, window.jQuery, window.console );
